__author__ = "Neil Muller"
__copyright__ = "Copyright (c) 2007 Neil Muller"
__license__ = "MIT-style"

"""
Not yet pong
"""

import pygame
import sys, os

def setup(tSize):
    pygame.display.init()
    try:
        pygame.font.init()
    except Exception, e:
        print "Unable to initialise font module"
        print e
        sys.exit()
    try:
        pygame.mixer.init()
    except Exception, e:
        print "Unable to initialise sound mixer module"
        print e
        sys.exit()
    pygame.display.set_mode(tSize)
    pygame.display.set_caption("Not Pong")
    return pygame.display.get_surface()

def createBackground(oScreen):
    oBackground=oScreen.copy()
    oBackRect=oBackground.get_rect()

    oFont1=pygame.font.Font(None,80)
    oText1=oFont1.render("Not Pong",True,(128,128,128))
    oFont2=pygame.font.SysFont('Comic',70)
    oText2=oFont2.render("Move the paddle",True,(182, 0, 182))
    oText3=oFont2.render("to hit the ball",True,(182, 0, 182))
    iBlitHeight=5
    oBackground.blit(oText1,(15,iBlitHeight))
    iBlitHeight+=+oText1.get_height()
    oBackground.blit(oText2,(5,iBlitHeight))
    iBlitHeight+=+oText2.get_height()
    oBackground.blit(oText3,(5,iBlitHeight))
    iBlitHeight+=+oText3.get_height()
    oScreen.blit(oBackground,(0,0))

    return oBackground,iBlitHeight


def loadImageToSprite(file):
    name=os.path.join('images',file)
    oImage=pygame.image.load(name).convert_alpha()
    oRect=oImage.get_rect()
    oSprite=pygame.sprite.Sprite()
    oSprite.image=oImage
    oSprite.rect=oRect
    return oSprite

def setupWalls(tSize):
    oSideWalls=pygame.sprite.AbstractGroup()
    oTopBotWalls=pygame.sprite.AbstractGroup()

    LeftWall=pygame.sprite.Sprite()
    LeftWall.rect=pygame.Rect((-10,0,10,tSize[1]))
    RightWall=pygame.sprite.Sprite()
    RightWall.rect=pygame.Rect((tSize[0],0,10,tSize[1]))
    oSideWalls.add((LeftWall,RightWall))

    TopWall=pygame.sprite.Sprite()
    TopWall.rect=pygame.Rect((0,-10,tSize[0],10))
    BottomWall=pygame.sprite.Sprite()
    BottomWall.rect=pygame.Rect((0,tSize[1],tSize[0],10))
    oTopBotWalls.add((TopWall,BottomWall))

    return oSideWalls,oTopBotWalls

def loadSound():
    name=os.path.join('sounds','clicked.wav')
    return pygame.mixer.Sound(name)

def playSound(oSound):
    if pygame.mixer.get_busy()==0:
        oSound.play()

if __name__=="__main__":
    tSize=(800,600)
    oScreen=setup(tSize)

    oBackground, iBlitHeight=createBackground(oScreen)

    pygame.display.update()
    aBallVelocity=[-2,2]
    oClock=pygame.time.Clock()

    oBallSprite=loadImageToSprite('blue_circ.png')
    oPaddleSprite=loadImageToSprite('paddle.png')

    oBallSprite.rect.move_ip(400,iBlitHeight)
    oPaddleSprite.rect.move_ip(120,iBlitHeight)
    oGroup=pygame.sprite.RenderUpdates()
    oGroup.add(oBallSprite)

    oPaddle=pygame.sprite.AbstractGroup()
    oPaddle.add(oPaddleSprite)
    oGroup.add(oPaddleSprite)

    oSideWalls,oTopBotWalls = setupWalls(tSize)

    oClick=loadSound()

    pygame.display.update(oGroup.draw(oScreen))

    bDownPressed=False
    bUpPressed=False
    while True:
        oClock.tick(90)
        iPaddleY=0
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                sys.exit()
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_q:
                    sys.exit()
                elif event.key == pygame.K_DOWN:
                    bDownPressed=True
                elif event.key == pygame.K_UP:
                    bUpPressed=True
            elif event.type == pygame.KEYUP:
                if event.key == pygame.K_DOWN:
                    bDownPressed=False
                elif event.key == pygame.K_UP:
                    bUpPressed=False

        if bDownPressed:
            iPaddleY=5
        elif bUpPressed:
            iPaddleY=-5

        oBallSprite.rect.move_ip(aBallVelocity[0],aBallVelocity[1])
        oPaddleSprite.rect.move_ip(0,iPaddleY)

        if pygame.sprite.spritecollideany(oBallSprite,oTopBotWalls) is not None:
            aBallVelocity[1]=-aBallVelocity[1]
            playSound(oClick)
        if pygame.sprite.spritecollideany(oBallSprite,oSideWalls) is not None:
            aBallVelocity[0]=-aBallVelocity[0]
            playSound(oClick)
        if pygame.sprite.spritecollideany(oBallSprite,oPaddle) is not None:
            aBallVelocity[0]=-aBallVelocity[0]
            playSound(oClick)

        oGroup.clear(oScreen,oBackground)
        pygame.display.update(oGroup.draw(oScreen))
